/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 31/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;
 
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.MapAngkaToBulan;
import com.portofolio.entity.vo.MapAngkaToBulanId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface MapAngkaToBulanDao extends CrudRepository<MapAngkaToBulan, MapAngkaToBulanId> {

 
	@Cacheable("MapAngkaToBulanDaofindOneBy")
	MapAngkaToBulan findOneByIdKdMappingAndIdKdProfileAndKdDepartemen(Integer kdMapping, Integer kdProfile,
			String KdDepartemen);
	 
	MapAngkaToBulan findOneByIdKdProfileAndNoUrut(Integer kdProfile, Integer noUrut);

	@Query(QListAll)
	@Cacheable("MapAngkaToBulanDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page,@Param("kdDepartemen") String KdDepartemen);
	
	@Query(QListAll + " and model.formatBulan like %:formatBulan% ")
	@Cacheable("MapAngkaToBulanDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("formatBulan") String formatBulan, Pageable page, @Param("kdDepartemen") String KdDepartemen);

	@Query(QListAll + " and model.id.kdMapping =:kdMapping ")
	@Cacheable("MapAngkaToBulanDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kdMapping") Integer kdMapping,
			@Param("kdDepartemen") String KdDepartemen);

	String QListAll = "select new map(model.id as kode " + ", model.formatAngka as formatAngka "
			+ ", model.formatBulan as formatBulan " + ", model.reportDisplay as reportDisplay "
			+ ", model.noUrut as noUrut " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " + ", model.kdDepartemen as kdDepartemen "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec "
			+ ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from MapAngkaToBulan model left join model.id id left join model.departemen departemen "
			+ " left join model.profile profile where profile.kode =:kdProfile and model.kdDepartemen =:kdDepartemen ";
			//+ "and model.statusEnabled = true ";

	@Query("select model from MapAngkaToBulan model where model.id.kdProfile=:kdProfile and model.noUrut =:noUrut "
			+ " and model.statusEnabled=true and model.id.kdMapping !=:kdMapping ")
	MapAngkaToBulan findByNoUrut(@Param("kdProfile")Integer kdProfile,
			@Param("noUrut") Integer noUrut,
			@Param("kdMapping") Integer kdMapping);
 
}
